"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __require = typeof require !== "undefined" ? require : (x) => {
  throw new Error('Dynamic require of "' + x + '" is not supported');
};
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};

// src/index.ts
__export(exports, {
  default: () => solidReactivityPlugin
});

// src/label-parser.ts
var t7 = __toModule(require("@babel/types"));

// src/get-hook-identifier.ts
var import_helper_module_imports = __toModule(require("@babel/helper-module-imports"));
function getHookIdentifier(hooks, path, name) {
  const current = hooks.get(name);
  if (current) {
    return current;
  }
  const newID = (0, import_helper_module_imports.addNamed)(path, name, "solid-js");
  hooks.set(name, newID);
  return newID;
}

// src/memo-variable.ts
var t3 = __toModule(require("@babel/types"));

// src/accessor-variable.ts
var t2 = __toModule(require("@babel/types"));

// src/deref-memo-expression.ts
var t = __toModule(require("@babel/types"));
function derefMemoExpression(path, memoIdentifier, readIdentifier) {
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      CallExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (!t.isIdentifier(p.node.callee)) {
          return;
        }
        switch (p.node.callee.name) {
          case "$refMemo":
            if (!t.isIdentifier(p.node.arguments[0])) {
              throw new Error("Expected identifier");
            }
            if (p.node.arguments[0].name === memoIdentifier.name) {
              p.replaceWith(readIdentifier);
            }
            break;
          case "$get":
            if (!t.isIdentifier(p.node.arguments[0])) {
              throw new Error("Expected identifier");
            }
            if (p.node.arguments[0].name === memoIdentifier.name) {
              p.replaceWith(readIdentifier);
            }
            break;
          default:
            break;
        }
      },
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && t.isIdentifier(p.node.key) && p.node.key.name === memoIdentifier.name && t.isIdentifier(p.node.value) && p.node.value.name === memoIdentifier.name) {
          p.replaceWith(t.objectProperty(memoIdentifier, t.callExpression(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== memoIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (t.isObjectMethod(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t.isObjectProperty(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t.isVariableDeclarator(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t.isArrayPattern(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (t.isArrowFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isFunctionDeclaration(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isLabeledStatement(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (t.isMemberExpression(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (t.isFunctionDeclaration(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t.isAssignmentPattern(p.parent) && p.parent.left === p.node && (t.isArrowFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t.isFunctionDeclaration(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t.isFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(t.callExpression(readIdentifier, []));
      }
    });
  }
}

// src/accessor-variable.ts
function accessorVariableExpression(hooks, path, accessorIdentifier, mod, replacement) {
  const readIdentifier = path.scope.generateUidIdentifier(accessorIdentifier.name);
  path.node.id = readIdentifier;
  path.node.init = t2.callExpression(getHookIdentifier(hooks, path, mod), replacement);
  derefMemoExpression(path, accessorIdentifier, readIdentifier);
}

// src/memo-variable.ts
function memoVariableExpression(hooks, path, memoIdentifier, stateIdentifier, optionsIdentifier) {
  accessorVariableExpression(hooks, path, memoIdentifier, "createMemo", [
    t3.arrowFunctionExpression([], stateIdentifier),
    t3.identifier("undefined"),
    t3.objectExpression([
      t3.objectProperty(t3.identifier("name"), t3.stringLiteral(memoIdentifier.name)),
      ...optionsIdentifier ? [t3.spreadElement(optionsIdentifier)] : []
    ])
  ]);
}

// src/signal-variable.ts
var t5 = __toModule(require("@babel/types"));

// src/deref-signal-expression.ts
var t4 = __toModule(require("@babel/types"));
function derefSignalExpression(path, signalIdentifier, readIdentifier, writeIdentifier) {
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      CallExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (!t4.isIdentifier(p.node.callee)) {
          return;
        }
        switch (p.node.callee.name) {
          case "$refSignal":
            if (!t4.isIdentifier(p.node.arguments[0])) {
              throw new Error("Expected identifier");
            }
            if (p.node.arguments[0].name === signalIdentifier.name) {
              p.replaceWith(t4.arrayExpression([
                readIdentifier,
                writeIdentifier
              ]));
            }
            break;
          case "$get":
            if (!t4.isIdentifier(p.node.arguments[0])) {
              throw new Error("Expected identifier");
            }
            if (p.node.arguments[0].name === signalIdentifier.name) {
              p.replaceWith(readIdentifier);
            }
            break;
          case "$set":
            if (!t4.isIdentifier(p.node.arguments[0])) {
              throw new Error("Expected identifier");
            }
            if (p.node.arguments[0].name === signalIdentifier.name) {
              p.replaceWith(writeIdentifier);
            }
            break;
          default:
            break;
        }
      },
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && t4.isIdentifier(p.node.key) && p.node.key.name === signalIdentifier.name && t4.isIdentifier(p.node.value) && p.node.value.name === signalIdentifier.name) {
          p.replaceWith(t4.objectProperty(signalIdentifier, t4.callExpression(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== signalIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (t4.isObjectMethod(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t4.isObjectProperty(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t4.isVariableDeclarator(p.parent)) {
          if (p.parent.id === p.node) {
            return;
          }
        }
        if (t4.isArrayPattern(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (t4.isArrowFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t4.isFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t4.isFunctionDeclaration(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t4.isLabeledStatement(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (t4.isMemberExpression(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (t4.isFunctionDeclaration(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t4.isAssignmentPattern(p.parent) && p.parent.left === p.node && (t4.isArrowFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t4.isFunctionDeclaration(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t4.isFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(t4.callExpression(readIdentifier, []));
      },
      UpdateExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (t4.isIdentifier(p.node.argument) && p.node.argument.name === signalIdentifier.name) {
          const param = p.scope.generateUidIdentifier("current");
          if (p.node.prefix) {
            p.replaceWith(t4.callExpression(writeIdentifier, [
              t4.arrowFunctionExpression([param], t4.binaryExpression(p.node.operator === "++" ? "+" : "-", param, t4.numericLiteral(1)))
            ]));
          } else {
            p.replaceWith(t4.callExpression(t4.arrowFunctionExpression([], t4.blockStatement([
              t4.variableDeclaration("const", [
                t4.variableDeclarator(param, t4.callExpression(readIdentifier, []))
              ]),
              t4.expressionStatement(t4.callExpression(writeIdentifier, [
                t4.arrowFunctionExpression([], t4.binaryExpression(p.node.operator === "++" ? "+" : "-", param, t4.numericLiteral(1)))
              ])),
              t4.returnStatement(param)
            ])), []));
          }
        }
      },
      AssignmentExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        const identifier6 = p.node.left;
        const expression = p.node.right;
        if (t4.isIdentifier(identifier6) && identifier6.name === signalIdentifier.name) {
          if (p.node.operator === "=") {
            p.replaceWith(t4.callExpression(writeIdentifier, [
              t4.arrowFunctionExpression([], expression)
            ]));
          } else {
            const param = p.scope.generateUidIdentifier("current");
            p.replaceWith(t4.callExpression(writeIdentifier, [
              t4.arrowFunctionExpression([param], t4.assignmentExpression(p.node.operator, param, expression))
            ]));
          }
        }
      }
    });
  }
}

// src/signal-variable.ts
function signalVariableExpression(hooks, path, signalIdentifier, stateIdentifier = t5.identifier("undefined"), optionsIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(signalIdentifier.name);
  const writeIdentifier = path.scope.generateUidIdentifier(`set${signalIdentifier.name}`);
  path.node.id = t5.arrayPattern([
    readIdentifier,
    writeIdentifier
  ]);
  path.node.init = t5.callExpression(getHookIdentifier(hooks, path, "createSignal"), [
    stateIdentifier,
    t5.objectExpression([
      t5.objectProperty(t5.identifier("name"), t5.stringLiteral(signalIdentifier.name)),
      ...optionsIdentifier ? [t5.spreadElement(optionsIdentifier)] : []
    ])
  ]);
  derefSignalExpression(path, signalIdentifier, readIdentifier, writeIdentifier);
}

// src/deferred-variable.ts
var t6 = __toModule(require("@babel/types"));
function deferredVariableExpression(hooks, path, deferredIdentifier, stateIdentifier = t6.identifier("undefined"), optionsIdentifier) {
  accessorVariableExpression(hooks, path, deferredIdentifier, "createDeferred", [
    t6.arrowFunctionExpression([], stateIdentifier),
    t6.objectExpression([
      t6.objectProperty(t6.identifier("name"), t6.stringLiteral(deferredIdentifier.name)),
      ...optionsIdentifier ? [t6.spreadElement(optionsIdentifier)] : []
    ])
  ]);
}

// src/label-parser.ts
function createVariableLabel(variableExpression) {
  return function(hooks, path) {
    const { body } = path.node;
    if (t7.isExpressionStatement(body)) {
      if (t7.isAssignmentExpression(body.expression)) {
        if (body.expression.operator !== "=") {
          throw new Error("Invalid assignment expression operator");
        }
        const leftExpr = body.expression.left;
        const rightExpr = body.expression.right;
        if (!t7.isIdentifier(leftExpr)) {
          throw new Error("Expected identifier");
        }
        path.replaceWith(t7.variableDeclaration("const", [
          t7.variableDeclarator(leftExpr, rightExpr)
        ]));
      } else if (t7.isIdentifier(body.expression)) {
        path.replaceWith(t7.variableDeclaration("const", [
          t7.variableDeclarator(body.expression)
        ]));
      } else if (t7.isSequenceExpression(body.expression)) {
        const exprs = [];
        for (let i = 0, len = body.expression.expressions.length; i < len; i += 1) {
          const expr = body.expression.expressions[i];
          if (t7.isIdentifier(expr)) {
            exprs.push(t7.variableDeclarator(expr));
          } else if (t7.isAssignmentExpression(expr)) {
            if (expr.operator !== "=") {
              throw new Error("Invalid assignment expression operator");
            }
            const leftExpr = expr.left;
            const rightExpr = expr.right;
            if (!t7.isIdentifier(leftExpr)) {
              throw new Error("Expected identifier");
            }
            path.replaceWith(t7.variableDeclarator(leftExpr, rightExpr));
          } else {
            throw new Error("Expected identifier or assignment expression");
          }
        }
        path.replaceWith(t7.variableDeclaration("const", exprs));
      }
    }
    if (t7.isVariableDeclaration(body)) {
      body.kind = "const";
      path.replaceWith(body);
    }
    if (t7.isVariableDeclaration(path.node)) {
      path.traverse({
        VariableDeclarator(p) {
          const leftExpr = p.node.id;
          const rightExpr = p.node.init;
          if (t7.isIdentifier(leftExpr)) {
            variableExpression(hooks, p, leftExpr, rightExpr != null ? rightExpr : t7.identifier("undefined"));
          }
        }
      });
    } else {
      throw new Error("Expected assignment expression or variable declaration");
    }
  };
}
function reactiveExpression(hooks, path) {
  const { body } = path.node;
  if (t7.isExpressionStatement(body)) {
    path.replaceWith(t7.callExpression(getHookIdentifier(hooks, path, "createEffect"), [
      t7.arrowFunctionExpression([], body.expression)
    ]));
  } else if (t7.isBlockStatement(body)) {
    path.replaceWith(t7.callExpression(getHookIdentifier(hooks, path, "createEffect"), [
      t7.arrowFunctionExpression([], body)
    ]));
  } else if (t7.isVariableDeclaration(body)) {
    body.kind = "const";
    path.replaceWith(body);
    path.traverse({
      VariableDeclarator(p) {
        const leftExpr = p.node.id;
        const rightExpr = p.node.init;
        if (t7.isIdentifier(leftExpr)) {
          memoVariableExpression(hooks, p, leftExpr, rightExpr != null ? rightExpr : t7.identifier("undefined"));
        }
      }
    });
  }
}
function createCallbackLabel(label) {
  return function expr(hooks, path) {
    const { body } = path.node;
    let callback;
    if (t7.isBlockStatement(body)) {
      callback = t7.arrowFunctionExpression([], body);
    } else if (t7.isExpressionStatement(body)) {
      callback = body.expression;
    } else {
      throw new Error("Expected arrow function or block expression");
    }
    path.replaceWith(t7.callExpression(getHookIdentifier(hooks, path, label), [
      callback
    ]));
  };
}
var EXPRESSIONS = {
  $: reactiveExpression,
  signal: createVariableLabel(signalVariableExpression),
  memo: createVariableLabel(memoVariableExpression),
  deferred: createVariableLabel(deferredVariableExpression),
  children: createVariableLabel((hooks, path, leftExpr, rightExpr) => {
    accessorVariableExpression(hooks, path, leftExpr, "children", [
      t7.arrowFunctionExpression([], rightExpr != null ? rightExpr : t7.identifier("undefined"))
    ]);
  }),
  effect: createCallbackLabel("createEffect"),
  computed: createCallbackLabel("createComputed"),
  renderEffect: createCallbackLabel("createRenderEffect"),
  mount: createCallbackLabel("onMount"),
  cleanup: createCallbackLabel("onCleanup"),
  error: createCallbackLabel("onError"),
  root: createCallbackLabel("createRoot"),
  untrack: createCallbackLabel("untrack"),
  batch: createCallbackLabel("batch"),
  transition: createCallbackLabel("startTransition")
};
var LABEL_PARSER = {
  LabeledStatement(path, state) {
    if (path.node.label.name in EXPRESSIONS) {
      EXPRESSIONS[path.node.label.name](state.hooks, path);
    }
  }
};
var label_parser_default = LABEL_PARSER;

// src/comment-parser.ts
var t8 = __toModule(require("@babel/types"));
function signalExpression(hooks, path) {
  path.traverse({
    VariableDeclarator(p) {
      const leftExpr = p.node.id;
      const rightExpr = p.node.init;
      if (t8.isIdentifier(leftExpr)) {
        signalVariableExpression(hooks, p, leftExpr, rightExpr != null ? rightExpr : void 0);
      }
    }
  });
}
function memoExpression(hooks, path) {
  path.traverse({
    VariableDeclarator(p) {
      const leftExpr = p.node.id;
      const rightExpr = p.node.init;
      if (t8.isIdentifier(leftExpr)) {
        memoVariableExpression(hooks, p, leftExpr, rightExpr != null ? rightExpr : t8.identifier("undefined"));
      }
    }
  });
}
function deferredExpression(hooks, path) {
  path.traverse({
    VariableDeclarator(p) {
      const leftExpr = p.node.id;
      const rightExpr = p.node.init;
      if (t8.isIdentifier(leftExpr)) {
        deferredVariableExpression(hooks, p, leftExpr, rightExpr != null ? rightExpr : t8.identifier("undefined"));
      }
    }
  });
}
function childrenExpression(hooks, path) {
  path.traverse({
    VariableDeclarator(p) {
      const leftExpr = p.node.id;
      const rightExpr = p.node.init;
      if (t8.isIdentifier(leftExpr)) {
        accessorVariableExpression(hooks, p, leftExpr, "children", [
          t8.arrowFunctionExpression([], rightExpr != null ? rightExpr : t8.identifier("undefined"))
        ]);
      }
    }
  });
}
function createCallbackLabel2(label) {
  return function expr(hooks, path) {
    const body = path.node;
    let callback;
    if (t8.isBlockStatement(body)) {
      callback = t8.arrowFunctionExpression([], body);
    } else if (t8.isExpressionStatement(body)) {
      callback = body.expression;
    } else {
      throw new Error("Expected arrow function or block expression");
    }
    path.replaceWith(t8.callExpression(getHookIdentifier(hooks, path, label), [
      callback
    ]));
  };
}
var STATE_EXPRESSIONS = {
  "@signal": signalExpression,
  "@memo": memoExpression,
  "@children": childrenExpression,
  "@deferred": deferredExpression
};
var CALLBACK_EXPRESSIONS = {
  "@effect": createCallbackLabel2("createEffect"),
  "@computed": createCallbackLabel2("createComputed"),
  "@renderEffect": createCallbackLabel2("createRenderEffect"),
  "@mount": createCallbackLabel2("onMount"),
  "@cleanup": createCallbackLabel2("onCleanup"),
  "@error": createCallbackLabel2("onError"),
  "@root": createCallbackLabel2("createRoot"),
  "@untrack": createCallbackLabel2("untrack"),
  "@batch": createCallbackLabel2("batch"),
  "@transition": createCallbackLabel2("startTransition")
};
var COMMENT_PARSER = {
  VariableDeclaration(path, state) {
    const comments = path.node.leadingComments;
    if (comments) {
      let preference;
      for (let i = 0, len = comments.length; i < len; i += 1) {
        const comment = comments[i];
        const value = comment.value.trim();
        if (value in STATE_EXPRESSIONS) {
          preference = value;
        }
      }
      if (preference) {
        STATE_EXPRESSIONS[preference](state.hooks, path);
      }
    }
  },
  BlockStatement(path, state) {
    var _a, _b;
    if (t8.isFunctionDeclaration(path.parent)) {
      return;
    }
    const comments = path.node.leadingComments;
    if (comments) {
      const leading = [];
      let preference;
      for (let i = 0, len = comments.length; i < len; i += 1) {
        const comment = comments[i];
        const value = comment.value.trim();
        if (value in CALLBACK_EXPRESSIONS) {
          preference = value;
        } else {
          leading.push(comment);
        }
      }
      const trailing = [...(_a = path.node.trailingComments) != null ? _a : []];
      const inner = [...(_b = path.node.innerComments) != null ? _b : []];
      t8.removeComments(path.node);
      t8.addComments(path.node, "leading", leading);
      t8.addComments(path.node, "inner", inner);
      t8.addComments(path.node, "trailing", trailing);
      if (preference) {
        CALLBACK_EXPRESSIONS[preference](state.hooks, path);
      }
    }
  },
  ExpressionStatement(path, state) {
    var _a, _b;
    const comments = path.node.leadingComments;
    if (comments) {
      const leading = [];
      let preference;
      for (let i = 0, len = comments.length; i < len; i += 1) {
        const comment = comments[i];
        const value = comment.value.trim();
        if (value in CALLBACK_EXPRESSIONS) {
          preference = value;
        } else {
          leading.push(comment);
        }
      }
      const trailing = [...(_a = path.node.trailingComments) != null ? _a : []];
      const inner = [...(_b = path.node.innerComments) != null ? _b : []];
      t8.removeComments(path.node);
      t8.addComments(path.node, "leading", leading);
      t8.addComments(path.node, "inner", inner);
      t8.addComments(path.node, "trailing", trailing);
      if (preference) {
        CALLBACK_EXPRESSIONS[preference](state.hooks, path);
      }
    }
  }
};
var comment_parser_default = COMMENT_PARSER;

// src/ctf-parser.ts
var t10 = __toModule(require("@babel/types"));

// src/deref-signal-variable.ts
var t9 = __toModule(require("@babel/types"));
function derefSignalVariableExpression(path, signalIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(signalIdentifier.name);
  const writeIdentifier = path.scope.generateUidIdentifier(`set${signalIdentifier.name}`);
  path.node.id = t9.arrayPattern([
    readIdentifier,
    writeIdentifier
  ]);
  path.node.init = stateIdentifier;
  derefSignalExpression(path, signalIdentifier, readIdentifier, writeIdentifier);
}

// src/deref-memo-variable.ts
function derefMemoVariableExpression(path, memoIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(memoIdentifier.name);
  path.node.id = readIdentifier;
  path.node.init = stateIdentifier;
  derefMemoExpression(path, memoIdentifier, readIdentifier);
}

// src/ctf-parser.ts
function derefSignalExpression2(_, path) {
  if (path.node.arguments.length > 1) {
    throw new Error("Expected argument length");
  }
  const argument = path.node.arguments[0];
  if (!t10.isExpression(argument)) {
    throw new Error("Expected expression");
  }
  if (!t10.isVariableDeclarator(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!t10.isIdentifier(leftExpr)) {
    throw new Error("Expected identifier");
  }
  derefSignalVariableExpression(path.parentPath, leftExpr, argument);
}
function signalExpression2(hooks, path) {
  if (path.node.arguments.length > 2) {
    throw new Error("Expected argument length");
  }
  let argument;
  let options;
  if (path.node.arguments.length > 0) {
    const state = path.node.arguments[0];
    if (!t10.isExpression(state)) {
      throw new Error("Expected expression");
    }
    argument = state;
    if (path.node.arguments.length > 1) {
      const optionsValue = path.node.arguments[1];
      if (!t10.isExpression(optionsValue)) {
        throw new Error("Expected expression");
      }
      options = optionsValue;
    }
  }
  if (!t10.isVariableDeclarator(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!t10.isIdentifier(leftExpr)) {
    throw new Error("Expected identifier");
  }
  signalVariableExpression(hooks, path.parentPath, leftExpr, argument, options);
}
function derefMemoExpression2(_, path) {
  if (path.node.arguments.length > 1) {
    throw new Error("Expected argument length");
  }
  const argument = path.node.arguments[0];
  if (!t10.isExpression(argument)) {
    throw new Error("Expected expression");
  }
  if (!t10.isVariableDeclarator(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!t10.isIdentifier(leftExpr)) {
    throw new Error("Expected identifier");
  }
  derefMemoVariableExpression(path.parentPath, leftExpr, argument);
}
function memoExpression2(hooks, path) {
  if (path.node.arguments.length > 2) {
    throw new Error("Expected argument length");
  }
  const argument = path.node.arguments[0];
  if (!t10.isExpression(argument)) {
    throw new Error("Expected expression");
  }
  let options;
  if (path.node.arguments.length > 1) {
    const optionsValue = path.node.arguments[1];
    if (!t10.isExpression(optionsValue)) {
      throw new Error("Expected expression");
    }
    options = optionsValue;
  }
  if (!t10.isVariableDeclarator(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!t10.isIdentifier(leftExpr)) {
    throw new Error("Expected identifier");
  }
  memoVariableExpression(hooks, path.parentPath, leftExpr, argument, options);
}
function deferredExpression2(hooks, path) {
  if (path.node.arguments.length > 2) {
    throw new Error("Expected argument length");
  }
  let argument;
  let options;
  if (path.node.arguments.length > 0) {
    const state = path.node.arguments[0];
    if (!t10.isExpression(state)) {
      throw new Error("Expected expression");
    }
    argument = state;
    if (path.node.arguments.length > 1) {
      const optionsValue = path.node.arguments[1];
      if (!t10.isExpression(optionsValue)) {
        throw new Error("Expected expression");
      }
      options = optionsValue;
    }
  }
  if (!t10.isVariableDeclarator(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!t10.isIdentifier(leftExpr)) {
    throw new Error("Expected identifier");
  }
  deferredVariableExpression(hooks, path.parentPath, leftExpr, argument, options);
}
function reactiveExpression2(hooks, path) {
  if (!path.parentPath) {
    throw new Error("Expected parent path");
  }
  const argument = path.node.arguments[0];
  if (!t10.isExpression(argument)) {
    throw new Error("Expected expression");
  }
  if (t10.isVariableDeclarator(path.parent)) {
    const leftExpr = path.parent.id;
    if (!t10.isIdentifier(leftExpr)) {
      throw new Error("Expected identifier");
    }
    memoVariableExpression(hooks, path.parentPath, leftExpr, argument);
  } else if (t10.isExpressionStatement(path.parent)) {
    path.replaceWith(t10.callExpression(getHookIdentifier(hooks, path, "createEffect"), [
      t10.arrowFunctionExpression([], argument)
    ]));
  } else {
    throw new Error("Expected expression statement or variable declarator.");
  }
}
function rootExpression(hooks, path) {
  if (!path.parentPath) {
    throw new Error("Expected parent path");
  }
  const argument = path.node.arguments[0];
  if (!t10.isExpression(argument)) {
    throw new Error("Expected expression");
  }
  const arrow = t10.isArrowFunctionExpression(argument) || t10.isFunctionExpression(argument) ? argument : t10.arrowFunctionExpression([], argument);
  path.replaceWith(t10.callExpression(getHookIdentifier(hooks, path, "createRoot"), [
    arrow
  ]));
}
function fromExpression(hooks, path) {
  const argument = path.node.arguments[0];
  if (!t10.isExpression(argument)) {
    throw new Error("Expected expression");
  }
  if (!t10.isVariableDeclarator(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!t10.isIdentifier(leftExpr)) {
    throw new Error("Expected identifier");
  }
  accessorVariableExpression(hooks, path.parentPath, leftExpr, "from", [
    argument
  ]);
}
function createCompileTimeAutoAccessor(target, limit) {
  return (hooks, path) => {
    if (path.node.arguments.length > limit) {
      throw new Error("Expected argument length");
    }
    const [argument, ...rest] = path.node.arguments;
    if (!t10.isExpression(argument)) {
      throw new Error("Expected expression");
    }
    if (!t10.isVariableDeclarator(path.parent) || !path.parentPath) {
      throw new Error("Expected variable declarator");
    }
    const leftExpr = path.parent.id;
    if (!t10.isIdentifier(leftExpr)) {
      throw new Error("Expected identifier");
    }
    accessorVariableExpression(hooks, path.parentPath, leftExpr, target, [
      t10.arrowFunctionExpression([], argument),
      ...rest
    ]);
  };
}
function createCompileTimeAlias(target) {
  return (hooks, path) => {
    path.node.callee = getHookIdentifier(hooks, path, target);
  };
}
function createCompileTimeAutoArrow(target, limit) {
  return (hooks, path) => {
    if (path.node.arguments.length > limit) {
      throw new Error("Expected argument length");
    }
    const [argument, ...rest] = path.node.arguments;
    if (!t10.isExpression(argument)) {
      throw new Error("Expected expression");
    }
    path.replaceWith(t10.callExpression(getHookIdentifier(hooks, path, target), [
      t10.arrowFunctionExpression([], argument),
      ...rest
    ]));
  };
}
var CTF_EXPRESSIONS = {
  $: reactiveExpression2,
  $derefSignal: derefSignalExpression2,
  $derefMemo: derefMemoExpression2,
  $signal: signalExpression2,
  $memo: memoExpression2,
  $root: rootExpression,
  $from: fromExpression,
  $deferred: deferredExpression2,
  $children: createCompileTimeAutoAccessor("children", 1),
  $mapArray: createCompileTimeAutoAccessor("mapArray", 3),
  $indexArray: createCompileTimeAutoAccessor("indexArray", 3),
  $lazy: createCompileTimeAutoArrow("lazy", 1),
  $untrack: createCompileTimeAutoArrow("untrack", 1),
  $batch: createCompileTimeAutoArrow("batch", 1),
  $observable: createCompileTimeAutoArrow("observable", 1),
  $selector: createCompileTimeAutoArrow("createSelector", 1),
  $on: createCompileTimeAutoArrow("on", 3),
  $useContext: createCompileTimeAlias("useContext"),
  $createContext: createCompileTimeAlias("createContext"),
  $uid: createCompileTimeAlias("createUniqueId"),
  $effect: createCompileTimeAlias("createEffect"),
  $computed: createCompileTimeAlias("createComputed"),
  $renderEffect: createCompileTimeAlias("createRenderEffect")
};
var CTF_PARSER = {
  CallExpression(path, state) {
    if (t10.isIdentifier(path.node.callee) && path.node.callee.name in CTF_EXPRESSIONS) {
      CTF_EXPRESSIONS[path.node.callee.name](state.hooks, path);
    }
  }
};
var ctf_parser_default = CTF_PARSER;

// src/index.ts
function solidReactivityPlugin() {
  return {
    pre() {
      this.hooks = new Map();
    },
    visitor: __spreadValues(__spreadValues(__spreadValues({}, label_parser_default), comment_parser_default), ctf_parser_default)
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
//# sourceMappingURL=index.js.map
